package com.github.itzilly.sbt.features.gardener

import com.github.itzilly.sbt.mixin.KeyBindingAccessor
import com.github.itzilly.sbt.util.Chatterbox
import net.minecraft.client.Minecraft
import net.minecraft.client.gui.GuiChat
import net.minecraft.client.settings.KeyBinding
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent
import net.minecraftforge.fml.common.gameevent.TickEvent
import net.minecraftforge.fml.common.gameevent.TickEvent.ClientTickEvent


object CaneMacroer {
    var isMacroToggled: Boolean = false
    val mc = Minecraft.getMinecraft()
    var activeKeys: MutableList<KeyBindingAccessor> = mutableListOf()

    @SubscribeEvent
    fun onTick(event: ClientTickEvent) {
        if (event.phase != TickEvent.Phase.END) return

        if (!isMacroToggled) return

        val canRunMacro = mc.currentScreen == null || mc.currentScreen is GuiChat
        if (!canRunMacro) {
            isMacroToggled = false
            Chatterbox.say("Disabled macro!")
            stop()
        }

        val myKey = mc.gameSettings.keyBindForward as KeyBindingAccessor
        pressKey(mc.gameSettings.keyBindForward.keyCode)
    }

    fun stop() {
        KeyBinding.setKeyBindState(mc.gameSettings.keyBindForward.keyCode, false)
        KeyBinding.setKeyBindState(mc.gameSettings.keyBindAttack.keyCode, false)
    }

//    private fun pressKey(key: KeyBindingAccessor) {
//        key.setPressed(true)
//        activeKeys.add(key)
//    }

    private fun pressKey(keyCode: Int) {
        KeyBinding.setKeyBindState(keyCode, true)
    }
}